
% set the end-points of Omega
geom.xa=0;
geom.xb=1;
% set the coefficients of the pde and the right hand side 
fun_set=setfun_ell_1d;
problem_data.f=@(x)fun_set.ff(x);
problem_data.gd0=fun_set.gd(geom.xa);
problem_data.gd1=fun_set.gd(geom.xb);
problem_data.gn0=-fun_set.gn(geom.xa);
problem_data.gn1=fun_set.gn(geom.xb);
problem_data.mu=fun_set.nu(0);
problem_data.sigma=fun_set.gam(0);
% 

% carico puntiforme
%problem_data.f=@(x)-(x==0.5);
% problem_data.gd0=0;
% problem_data.gd1=0;
% problem_data.gn0=0;
% problem_data.gn1=0;
% problem_data.mu=1;
% problem_data.sigma=0;


% set the boundary conditions at the end-points
problem_data.bc='dd';

% reazione diffusione
% problem_data.f=@(x)1+0*x;
% problem_data.gd0=1;
% problem_data.gd1=2;
% problem_data.gn0=0;
% problem_data.gn1=0;
% problem_data.mu=1;
% problem_data.sigma=0;
% 
p=1; % local polynomial degree

errl2=[];  errh1=[]; H=[]; % to store the errors

for Ne=5; [10:10:100] % number of elements
H=[H;1/Ne];

% solve the pde
[nodes,uh]=fem_1d_solver(geom,problem_data,p,Ne);
soglia=sqrt(6*problem_data.mu/problem_data.sigma);
% plot the solution
figure(1); clf

plot(nodes,uh,'o-','Linewidth',2);
hold on
grid on
 fplot(fun_set.uex,[nodes(1),nodes(end)],'Linewidth',2)
 legend('u_h(x)','u(x)')
xlabel('x')
ylabel('y')
set(gca,'Fontsize',16)
title(['Ne=',num2str(Ne),' h=',num2str(1/Ne),' sqrt(6mu)=',num2str(soglia)])
% compute the errors
% uex=@(x)fun_set.uex(x);
% u1ex=@(x)fun_set.uexx(x);
% errors=fem_1d_errors(uh,geom,p,Ne,uex,u1ex);
% errl2=[errl2;errors.l2];
% errh1=[errh1;errors.h1];
%pause
end

% plot the errors
% errl2./H.^(p+1)
% errh1./H.^p
